"use strict";
const core_1 = require("@angular/core");
var Papa = require("papaparse");
class CSVExportFile {
    constructor() {
        this.file_name = "CSV";
        this.file_extension = "csv";
    }
}
exports.CSVExportFile = CSVExportFile;
exports.CSV_EXPORT_TYPES = {
    CSV: "exportCSV",
    JSON: "exportJSON"
};
class CSVExport {
    constructor() {
        this.JSONEmiter = new core_1.EventEmitter();
        this.fileData = new CSVExportFile();
    }
    setFileData(fileData) {
        this.fileData = fileData;
    }
    export() {
        switch (this.exportType) {
            case exports.CSV_EXPORT_TYPES.CSV:
                this.exportCSV();
                break;
            case exports.CSV_EXPORT_TYPES.JSON:
                this.exportJSON();
                break;
            default:
                this.exportCSV();
        }
    }
    setJSON(json) {
        this.json = json;
    }
    setExportType(type) {
        this.exportType = type;
    }
    exportCSV() {
        new TextFileDownloader(Papa.unparse(this.json), this.fileData.file_name, this.fileData.file_extension);
    }
    exportJSON() {
        this.JSONEmiter.emit(this.json);
    }
}
exports.CSVExport = CSVExport;
class TextFileDownloader {
    constructor(content, file_name = "Sample", file_extension = "txt") {
        this.content = content;
        this.file_name = file_name;
        this.file_extension = file_extension;
        this.downloadTextFile();
    }
    createTextFile() {
        // var data = new Blob([this.content], {type: 'text/plain'});
        // return window.URL.createObjectURL(data);
    }
    downloadTextFile() {
        // var link = document.createElement('a');
        // link.setAttribute('download', this.file_name +"."+ this.file_extension);
        // link.href = this.createTextFile();
        // document.body.appendChild(link);
        //
        // // wait for the link to be added to the document
        // window.requestAnimationFrame(function () {
        //     var event = new MouseEvent('click');
        //     link.dispatchEvent(event);
        //     document.body.removeChild(link);
        // });
    }
}
exports.TextFileDownloader = TextFileDownloader;
//# sourceMappingURL=csv-export.js.map