import {EventEmitter} from "@angular/core";
var Papa = require("papaparse");

export class CSVExportFile{
    file_name = "CSV";
    file_extension = "csv";
}

export const CSV_EXPORT_TYPES = {
    CSV:"exportCSV",
    JSON:"exportJSON"
};

export class CSVExport{

    private json;
    private exportType:string;
    public JSONEmiter = new EventEmitter();

    private fileData:CSVExportFile = new CSVExportFile();

    setFileData(fileData:CSVExportFile){
        this.fileData = fileData;
    }

    export(){
        switch(this.exportType) {
            case CSV_EXPORT_TYPES.CSV:
                this.exportCSV();
                break;
            case CSV_EXPORT_TYPES.JSON:
                this.exportJSON();
                break;
            default:
                this.exportCSV();
        }
    }

    setJSON(json){
        this.json = json;
    }

    setExportType(type){
        this.exportType = type;
    }

    exportCSV(){
        new TextFileDownloader(
            Papa.unparse(this.json),
            this.fileData.file_name,
            this.fileData.file_extension);
    }

    exportJSON(){
        this.JSONEmiter.emit(this.json);
    }

}

export class TextFileDownloader{

    private fileblob;

    constructor(
        private content:string,
        private file_name:string = "Sample",
        private file_extension:string = "txt"
    ){
        this.downloadTextFile();
    }

    private createTextFile(){
        // var data = new Blob([this.content], {type: 'text/plain'});
        // return window.URL.createObjectURL(data);
    }

    private downloadTextFile(){
        // var link = document.createElement('a');
        // link.setAttribute('download', this.file_name +"."+ this.file_extension);
        // link.href = this.createTextFile();
        // document.body.appendChild(link);
        //
        // // wait for the link to be added to the document
        // window.requestAnimationFrame(function () {
        //     var event = new MouseEvent('click');
        //     link.dispatchEvent(event);
        //     document.body.removeChild(link);
        // });
    }

}

