"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const core_1 = require("@angular/core");
const csv_parse_1 = require("./csv-service/csv-parse");
const csv_import_1 = require("./csv-service/csv-import");
const csv_export_1 = require("./csv-service/csv-export");
let CSVService = class CSVService {
    constructor(zone) {
        this.zone = zone;
        //parser parse csv data and return multidimensional array
        this.parser = new csv_parse_1.CSVParser();
        //handler handling multidimensional array and make object array,
        //Object key set with this.handler.setDataHeaders
        this.handler = new csv_import_1.CSVHandler();
        //Exporting csv file
        this.exporter = new csv_export_1.CSVExport();
        //EVENTS
        //Finished parsing and showing data
        this.onCSVParseCompleate();
        //Data ready
        this.onDataImport();
    }
    parse(file, encoding = null) {
        //Set file
        this.parser.setFile(file);
        //Start parse
        this.parser.parse(encoding);
    }
    setDataHeader(header) {
        this.dataHeaders = header;
    }
    onCSVParseCompleate() {
        //Finished parsing and showing data
        this.parser.complete.subscribe((data) => {
            this.zone.run(() => {
                //Processing data and preparing to exportData
                this.handler.setRows(data.rows);
                this.handler.setDataHeaders(this.dataHeaders);
                this.handler.setHeaders(data.headers);
            });
        });
    }
    onDataImport() {
        //EXPORT EVENT FIRED WHEN TRIGGERED  this.csv.handler.exportData();
        this.handler.dataImported.subscribe((data) => {
            this.exporter.setJSON(data);
            //EXport data
            this.exporter.export();
        });
    }
};
CSVService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [core_1.NgZone])
], CSVService);
exports.CSVService = CSVService;
//# sourceMappingURL=csv.service.js.map